BaseDir="D:/Dev/Projects/Apocalyptical Age/Source/Render"
IncludeDirs=r'/I"C:\Libs\boost\boost_1_55_0" /I"C:\Libs\Assimp\install\include" /I"C:\Libs\glm" /I"D:\Dev\Projects\Apocalyptical Age\Source\Utilities" /I"C:\Libs\FreeImage\Dist"'
IncludeDirs=IncludeDirs.replace("/I", "-I")


def AnalyzeFile(FileName):
    import subprocess, os
    Command='clang-IWYU.exe ' + IncludeDirs + ' -w ' + ' --cwd="'+ BaseDir + '"' + ' "' + FileName + '"'
    #print(Command)
    #os.system(Command)

    def run_command(command):
        p = subprocess.Popen(command, stdout=subprocess.PIPE, stderr=subprocess.STDOUT)
        return iter(p.stdout.readline, b'')
    
    Start=False
    Result=""
    for l in run_command(Command):
        line=l.decode("utf8")
        if " should add these lines:" in line:
            Start=True
        if Start:
            Result+=line
    
    return Result
    

def AnalyzeDirectory(Directory):
    import os
    from os.path import join, relpath
    file=open(join(Directory, "IWYU-Result.txt"), "w")
    ext=(".h", ".hpp", ".c", ".cpp", ".inl")
    for root, dirs, files in os.walk(Directory):
        for name in files:
            if name.endswith(ext):
                print("analyzing ", join(root, name))
                FileRes=AnalyzeFile(join(root, name))
                #print(FileRes)
                file.write("------- "+name+" ---------\n")
                file.write(FileRes)
                file.write("\n\n\n\n")
                file.flush()
                os.fsync(file)
    file.close()            
                
AnalyzeDirectory(BaseDir)